/************************************************************************** 
 *     NNstat -- Internet Statistics Collection Package                   *
 *                                                                        *
 *        Written by: Bob Braden & Annette DeSchon                        *
 *        USC Information Sciences Institute                              *
 *        Marina del Rey, California                                      *
 *        1987-1988                                                       *
 *                                                                        *
 *     NNStat is Public Domain, and may be used for any purpose as long   *
 *     as this notice is not removed.                                     *
 **************************************************************************/

#include "stat.h"
 
#define MAX_ADDRS 20
#define MAX_STATS 50
#define TIMEOUT  60

#ifndef FALSE
#define FALSE   0       /* logical false */
#define TRUE    !FALSE  /* logical true */
#endif

/*
 * CHANGES: 27Jan89 ISI:  Fix typedefs, increase MAX_ADDRS
 */
 
typedef struct obj_desc {
        boolean query,
                saventry;
        char    sname[MAX_OBJNAME+1],           /* object name */
                fname[28+MAX_OBJNAME+1];        /* log file */
/*              15(host) + 1(-) + 12(date) = 28 */
        FILE    *logptr;
        long     logindex;
        long    rtime,
                ctime;
        } obj_desc;

typedef struct collector {
        char            hostname[256];
        struct in_addr  inetaddr;
        long            readtime,
                        creation,
                        nextclear;
                        
        /* array of structures for things to collect */
        struct obj_desc s[MAX_STATS];
        } collector;
        
