#
#  R2.4: bug fixed, updated to work with byte-counting objects (but does not
#            accumulate bytes)
#
BEGIN {file = ""; startC = 0}

$0 ~ /Log created/ , $0 ~ /Object name/ {
   if (file != FILENAME) {
      if (startC != 0) {
          totalC += latestC - startC;
# 
# Grand Total Calculation:
#    GT = LastCount - FirstCount + (sum of all counts taken right before
#                                   reinitialization has taken place)
#  
          print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
          print "\nGrand Total = " totalC " (" starttime " to " endtime ")\n"
          if (v == 1) print "\f"
      }
      startC = 0; latestC = 0; totalC = 0;
      file = FILENAME; cleartime = "";
      printf "\nFile: " FILENAME "\n\n"
   }
   print
}

($1 == "ReadTime:") {
   day = substr($3, 1, (length($3)-4));
   if (startC == 0) starttime = $2 " " day
   time2 = endtime = $2 " " day
   temp = $5 " " substr($6, 1, (length($6)-3))
   if (cleartime == temp) {
      newclear = 0 
      out =  "\n  " time2 "\t\t"       # clear time same as last; don't display it.
   }
   else {
      out =  "\n  " time2 "    " temp  # new clear time
      newclear = 1;
   }
   cleartime = temp
   next #;
}

($1 == "Total" && $2 == "Count=") {
   if (startC == 0) {
      if (v == 1) {
        print "\n  Read-Time\t    Clear-Time\t       Total-Count\t Increment"
        print   "  ---------\t    ----------\t       -----------\t ---------"
        }
      daytotC = incC = 0
      startC = $3 + 0
      prevday = day
      time1 = starttime
      }
   else {
      if (newclear) {  # Cleared since last read => all counts are good.
        incC = $3 + 0;
        totalC += latestC
      } 
      else             # Not cleared => cumulative counts.
        incC = $3 - latestC
      daytotC += incC
   }
   latestC = $3 + 0
   if (v == 1) printf "%s\t%10d\t%10d", out, latestC, incC
   if (prevday != day) {
      print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
      if (v == 1) print "\n"
      time1 = time2
      prevday = day
      daytotC = 0
      }
   next #;
}

END {totalC += latestC - startC; 
     print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
     print "\nGrand Total = " totalC " (" starttime " to " endtime ")\n"
}
