#
#  R2.4: bug fixed, accumulates bytes for byte-counting objects.
#
BEGIN {file = ""; startC = 0; NeedTotals = 0}

$0 ~ /Log created/ , $0 ~ /Object name/ {
   if (file != FILENAME) {  # New file... finish previous one, if any.
      if (startC) {
         totalC += latestC - startC;
           if (startB) { 
              totalB += latestB - startB; 
              print "\nDaily total = " daytotC " &" daytotB "B  (" time1 " to "  \
                           time2 ")\n"
              print "\nGrand Total = " totalC " &" totalB "B (" starttime " to " \
                                   endtime ")\n" ;
           }
           else {
              print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
              print "\nGrand Total = " totalC " (" starttime " to " endtime ")\n"
           }
           if (v == 1) print "\f"
       }
       startC = latestC = totalC = 0;
       startB = latestB = totalB = 0;
       file = FILENAME; cleartime = "";
       printf "\nFile: " FILENAME "\n\n"
   }
   print
}

($1 == "ReadTime:") {
   day = substr($3, 1, (length($3)-4));
   if (startC == 0) starttime = $2 " " day
   time2 = endtime = $2 " " day
   temp = $5 " " substr($6, 1, (length($6)-3))
   if (cleartime == temp)  {
      out =  "\n  " time2 "\t\t"       # clear time same as last; don't display it.
      newclear = 0
   } 
   else {
      out =  "\n  " time2 "    " temp  # new clear time
      newclear = 1;
   }
   cleartime = temp
   next #;
}

($1 == "Total" && $2 == "Count=") {
   if (startC == 0) {
      if (v == 1) {
         print "\n  Read-Time\t    Clear-Time\t    Total-Count\t      Increment"
         print   "  ---------\t    ----------\t    -----------\t      ---------"
      }
      daytotC = incC = daytotB = incB = 0
      startC = $3 + 0
      prevday = day
      time1 = starttime
      }
   else {
      if (newclear) {  # Cleared since last read => all counts are good.
        incC = $3 + 0;
        totalC += latestC
      } 
      else             # Not cleared => cumulative counts.
        incC = $3 - latestC
      daytotC += incC
   }
   latestC = $3 + 0
   if (startB == 0) {
      if (v == 1) {
         printf "%s\t%9d\t%9d", out, latestC, incC
      }
      if (prevday != day) {
         print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
         if (v == 1) printf "\n"
         time1 = time2
         prevday = day
         daytotC = daytotB = 0;
      }
   }
}   # end of handling "Total Count= " line

($1 == "Total" && $2 == "Bytes=") {
   newB = substr($3, 1, length($3)-1) + 0
   if (startB) {
      if (newclear) {  # Cleared since last read => all counts are good.
        incB = newB;
        totalB += latestB
      } 
      else             # Not cleared => cumulative counts.
        incB = newB - latestB
   }
   daytotB += incB
   latestB = newB
   if (v == 1) {
      if (startB)
         printf "%s\t%9d\t%9d", out, latestC, incC
      printf "\n\t\t\t\t      &%12s  &%12dB\n", $3, incB
   }
   if (startB == 0)
      startB = newB
   else {
      if (prevday != day) {
         print "\nDaily total = " daytotC "  &" daytotB "B  (" time1 " to " time2 \
                                     ")\n"
         if (v == 1) print "\n"
         time1 = time2
         prevday = day
         daytotC = daytotB = 0;
         }
      }
}

END {
   totalC += latestC - startC; 
   if (startB) { 
      totalB += latestB - startB; 
      print "\nDaily total = " daytotC " &" daytotB "B  (" time1 " to " time2 \
                                     ")\n"
      print "\nGrand Total = " totalC " &" totalB "B (" starttime " to " \
                                                endtime ")\n" ;
   }
   else {
      print "\nDaily total = " daytotC " (" time1 " to " time2 ")\n"
      print "\nGrand Total = " totalC " (" starttime " to " endtime ")\n"
   }
}
