#ifndef lint
static  char sccsid[] = "@(#)rpc.etherd.c 1.1 86/02/05 Copyr 1985 Sun Micro";
#endif

/* 
 *  This routine is extracted from Sun Microsystems module protected by the
 *    following copyrights:
 *
 */
 
/*
 * Copyright (c) 1985 by Sun Microsystems, Inc.
 */

/* readether and initdevice for "SUNOS4" from s.nit_streams.c
 *
 * Copyright (c) 1987 by Sun Microsystems, Inc.
 */     

/* CHANGES:
 *    17Nov88 ISI:  read data from file instead of NIT, if TraceFile != NULL
 *    18Nov88 ISI:  Changes for SunOS 4.0
 *    18Nov88 ISI:  Change calling seq to parse()
 *    22Nov88 ISI:  Change initdevice call to pass Ethernet type, not device.
 *      Rel 2.4:
 *    01Nov89 ISI:  Pass received-length to parse()
 *
 */
  
#include <stdio.h>
#include <netdb.h>
#include <sys/types.h>
#include <sys/file.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <net/if.h>
#include <net/nit.h>

#ifdef SUNOS4
#include <sys/stream.h>
#include <sys/stropts.h>
#include <net/nit_if.h>
#include <net/nit_pf.h>
#include <net/nit_buf.h>
#include <net/packetfilt.h>
#endif

    /* Following needed for packet (size)  */
#include "packet.h"

#define DEBUG

#define CHUNKSIZE       3072    /* was 8192 */
#define BUFSPACE        4*CHUNKSIZE
#define ALIGNMENT        4   /* align on integer boundaries */
#define NIT_DEV         "/dev/nit"
#define FBUFSIZE        600000

extern int errno;
int  if_fd = -1;

#ifdef SUNOS4
int     tflag = 1;      /* true if NI_TIMESTAMP is set */
int     dflag = 1;      /* true if NI_DROPS is set */
/* NI_LEN is set if snaplen > 0 */
#endif
        
u_long  chunksize;
u_long  snaplen = ((sizeof(struct ether_header) 
                    + 64 /* Max IP hdr */
                    + sizeof(union ip_data)
		    + 3) / 4) * 4; /* even 4-byte boundary */
/* sizeof headers (20) + snaplen (108) = 128 */
/* (snaplen + nit headers) should ideally divide chunksize */

u_char  *buf;
#ifdef TRACEF
extern  char *TraceFile;  /* External trace file, or NULL */
#endif

/* extern int debug; */
int ndebug = 0;
                                    

readether()
{
    register u_char *bp, *bufstop, *cp;
    int cc, datalen, len;

#ifndef SUNOS4
    struct nit_hdr *nh;
#else
    struct timeval      *tvp;   /*  = NULL; */
    u_long              drops;  /*  = 0; */
    u_long              pktlen; 
    
    struct nit_bufhdr  *hdrp;
    struct nit_iftime  *ntp;
    struct nit_ifdrops *ndp;
    struct nit_iflen   *nlp;
    int header_size = ((tflag)?sizeof(*ntp):0) + 
                      ((dflag)?sizeof(*ndp):0) +
                      ((snaplen > 0)?sizeof(*nlp):0) + sizeof(*hdrp);
#endif
    
    bp =  buf;
    len = 0;  /* buffer is empty */
    
#ifdef TRACEF    
    while (1) {
#endif
    	
    	if (if_fd < 0) return;
    	
        if ((cc = read(if_fd, (char *)buf+len, (int)chunksize-len)) < 0) {
	    /* attempt to clear the error condition */
	    lseek(if_fd, 0, 0);
	    if ((cc = read(if_fd, (char *)buf+len, (int)chunksize-len)) < 0) {
		perror("Packet buffer read");
		exit(1);
		}
	    }
        len += cc;
        if (len == 0) {
#ifdef TRACEF    
            if (TraceFile) { /* EOF */
               close(if_fd);
               if_fd = -1;
            }  
#endif    
            return; 
        }        

        /*
         *   Loop through the buffer, obeying alignment rule. 
         */

        bufstop = buf + len;
#ifdef TRACEF    
        if (TraceFile) bufstop -= snaplen;  
                    /* If reading from file, have to allow for packet that
                     * overlaps from one read to the next...
                     */
#endif                        
#ifndef SUNOS4                                                  
                                                        
        for (bp = buf; bp < bufstop;
            bp += ((sizeof(struct nit_hdr)+datalen+ALIGNMENT-1) & 
                                                ~(ALIGNMENT-1))) {

            nh = (struct nit_hdr *) bp;
            cp = bp + sizeof(struct nit_hdr) ;
            datalen = nh->nh_datalen;

            if (nh->nh_state != NIT_CATCH) {
                switch (nh->nh_state) {
                case NIT_SEQNO:
                case NIT_NOMBUF:
                case NIT_NOCLUSTER:
                case NIT_NOSPACE:
                    datalen = 0;
		    continue;
                default:
                    fprintf(stderr, "NNStat: bad nit state %d\n", nh->nh_state);
		    continue;
                }
            }
	    
            /* Call parser with packet */        
            parse((struct packet *) cp, datalen,  nh->nh_wirelen, 
                                                       nh->nh_timestamp); 
                                                       
#else  /* SunOS 4.0 */

        for (bp = buf; bp < bufstop; bp += hdrp->nhb_totlen) {

            cp = bp;
            tvp = NULL;
            drops = 0;
        
            hdrp = (struct nit_bufhdr *)cp;
            cp += sizeof *hdrp;
            if (tflag) {
                ntp = (struct nit_iftime *)cp;
                cp += sizeof *ntp;
                tvp = &ntp->nh_timestamp;
            }

            if (dflag) {
                ndp = (struct nit_ifdrops *)cp;
                cp += sizeof *ndp;
                drops = ndp->nh_drops;
            }

            if (snaplen > 0) {
                nlp = (struct nit_iflen *)cp;
                cp += sizeof *nlp;
                pktlen = nlp->nh_pktlen;
            }
            else
                pktlen = hdrp->nhb_msglen;

            datalen = hdrp->nhb_totlen - header_size;

            if (datalen <= 16) { /* Only Ethernet header? */
               /* This is sure sign of 4.0 NIT bug fixed by Van Jacobson.
		  Must be fixed for statspy to work! */
               fprintf(stderr, "NNStat: Fatal NIT error");
               fprintf(stderr, "Statspy depends upon bug fix in nit_if.c");
               exit(1);
               }
	       
            parse((struct packet *) cp, datalen, pktlen, *tvp);

#ifdef DEBUG               
            if (ndebug==1) {
                fprintf(stdout,
                   "cc: %d, snaplen: %d, datalen: %d, pktlen: %d, drops: %d\n",
                   cc,snaplen,datalen,pktlen,drops);
		   }
#endif

#endif  /* 3.x, 4.0 NIT code */

        }  /* end loop through buffer */
#ifdef TRACEF	
        if (TraceFile) {
            /* Reading file.  Smush end of buffer back to beginning */
            memcpy(buf, bp, len = buf+len-bp);
        }
        else 
#endif	
	   return;
#ifdef TRACEF	
   }  /* End forever loop */
#endif	
    
} /* readether */


/*
 *   Create Network Interface Tap (NIT) Protocol socket and initialize it.
 *    Can look for specified Ethernet type, or NT_ALLTYPES.
 *
 */
initdevice(EtherType)
    int EtherType;
    {
    extern char *EtherIface;
#ifndef SUNOS4
    struct sockaddr_nit snit;
    struct nit_ioc nioc;
#else
    struct strioctl si;
    struct ifreq    ifr;
    struct timeval  timeout;
    u_long if_flags = 0;
#endif

    chunksize = 
#ifdef TRACEF    
    	(TraceFile)? FBUFSIZE: 
#endif	
	CHUNKSIZE;
      	
    if ((buf = (u_char *) malloc(chunksize)) == NULL) {
    	printf("MEMORY SHORTAGE: packet buf\n");
		exit(1);
    }      
#ifdef TRACEF    
    if (TraceFile) {
        /* Input is to come from trace file, not NIT */
        if  ((if_fd = open(TraceFile, O_RDONLY)) < 0) {
            perror("Cannot open trace file");
            exit(1);
        }
        return;
    };
#endif	
    
        /* Else open NIT device */     
#ifndef SUNOS4
    
    if (if_fd < 0) {
        if_fd = socket(AF_NIT, SOCK_RAW, NITPROTO_RAW);
        if (if_fd < 0) {
            perror("nit socket");
            exit(-1);
        }

        snit.snit_family = AF_NIT;
        strncpy(snit.snit_ifname, EtherIface, NITIFSIZ);
        if (bind(if_fd, &snit, sizeof(snit)) != 0) {
            perror(EtherIface);
            exit (1);
        }

        bzero(&nioc, sizeof(nioc));
        nioc.nioc_bufspace = BUFSPACE;
        nioc.nioc_chunksize = chunksize;
        nioc.nioc_typetomatch = EtherType;
        nioc.nioc_snaplen = snaplen;
        nioc.nioc_bufalign = ALIGNMENT ;
        nioc.nioc_bufoffset = 0;
        nioc.nioc_flags = NF_PROMISC|NF_TIMEOUT;
        nioc.nioc_timeout.tv_sec = 1;
        nioc.nioc_timeout.tv_usec = 0;

        if (ioctl(if_fd, SIOCSNIT, &nioc) != 0) {
            perror("nit ioctl");
            exit(1);
        }
    }

#else

        if ((if_fd = open(NIT_DEV, O_RDONLY)) < 0) {
                perror("nit open");
                exit (1);
        }

        /*
         * Arrange to get discrete messages from the stream.
         *      RMSGD is Message-discard mode.
         */
        if (ioctl(if_fd, I_SRDOPT, (char *)RMSGD) < 0) {
                perror("ioctl (I_SRDOPT)");
                exit (1);
        }

        si.ic_timout = INFTIM;

        /*
         * Push and configure the buffering module.
         */
        if (ioctl(if_fd, I_PUSH, "nbuf") < 0) {
                perror("ioctl (I_PUSH \"nbuf\")");
                exit (1);
        }
             /* Could push the filter module to look for specific
              *   Ethernet type.  Not implemented yet.
              */
        timeout.tv_sec = 1;
        timeout.tv_usec = 0;
        si.ic_cmd = NIOCSTIME;
        si.ic_len = sizeof timeout;
        si.ic_dp = (char *)&timeout;
        if (ioctl(if_fd, I_STR, (char *)&si) < 0) {
                perror("ioctl (I_STR: NIOCSTIME)");
                exit (1);
        }

        si.ic_cmd = NIOCSCHUNK;
        si.ic_len = sizeof chunksize;
        si.ic_dp = (char *)&chunksize;
        if (ioctl(if_fd, I_STR, (char *)&si) < 0) {
                perror("ioctl (I_STR: NIOCSCHUNK)");
                exit (1);
        }

        /*
         * Configure the nit device, binding it to the proper
         * underlying interface, setting the snapshot length,
         * and setting nit_if-level flags.
         */
        (void) strncpy(ifr.ifr_name, EtherIface, sizeof ifr.ifr_name);
        ifr.ifr_name[sizeof ifr.ifr_name - 1] = '\0';
        si.ic_cmd = NIOCBIND;
        si.ic_len = sizeof ifr;
        si.ic_dp = (char *)&ifr;
        if (ioctl(if_fd, I_STR, (char *)&si) < 0) {
                perror("ioctl (I_STR: NIOCBIND)");
                exit(1);
        }

        if (snaplen > 0) {
                si.ic_cmd = NIOCSSNAP;
                si.ic_len = sizeof snaplen;
                si.ic_dp = (char *)&snaplen;
                if (ioctl(if_fd, I_STR, (char *)&si) < 0) {
                        perror("ioctl (I_STR: NIOCSSNAP)");
                        exit (1);
                }
        }

        if_flags = NI_PROMISC;
        if (tflag) if_flags = if_flags | NI_TIMESTAMP;
        if (dflag) if_flags = if_flags | NI_DROPS;
        if (snaplen > 0) if_flags = if_flags | NI_LEN; 

        if (if_flags != 0) {
                si.ic_cmd = NIOCSFLAGS;
                si.ic_len = sizeof if_flags;
                si.ic_dp = (char *)&if_flags;
                if (ioctl(if_fd, I_STR, (char *)&si) < 0) {
                        perror("ioctl (I_STR: NIOCSFLAGS)");
                        exit (1);
                }
        }

        /*
         * Flush the read queue, to get rid of anything that
         * accumulated before the device reached its final configuration.
         */
/* *** Don't do this; there is a kernel bug that effectively sets the
	 snaplen to 0 whenever there is an I_FLUSH.
	 
        if (ioctl(if_fd, I_FLUSH, (char *)FLUSHR) < 0) {
                perror("ioctl (I_FLUSH)");
                exit(1);
        }
*** */

#endif

} /* initdevice */

deinitdevice()
{
    close(if_fd);
    if_fd = -1;
    free(buf);
}
    
