/************************************************************************** 
 *     NNstat -- Internet Statistics Collection Package                   *
 *                                                                        *
 *        Written by: Bob Braden & Annette DeSchon                        *
 *        USC Information Sciences Institute                              *
 *        Marina del Rey, California                                      *
 *        1987-1988                                                       *
 *                                                                        *
 *     NNStat is Public Domain, and may be used for any purpose as long   *
 *     as this notice is not removed.                                     *
 **************************************************************************/

/*   PACKET STATISTICS COLLECTION PROGRAM
 *
 */

#include <net/if.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/ip.h>
#include <netinet/if_ether.h>
#include <netinet/udp.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#ifdef IBMRTPC
#include <sys/enet.h>
#endif

		/* Fixed Structure of a Packet */
		
struct packet {
	struct  ether_header pk_eheader;
	union   {
		struct ether_arp pk_arphdr;
		struct ip_pkt {
			struct ip pk_iphdr ;
			   /* IP header is variable-length.  Followed by union ip_data */
		} ip_struct ;
	} ether_data ;
			
} ;
		
	  /* Contents of IP datagram */
		
union ip_data {
	struct icmp pk_icmphdr ;
	struct tcphdr pk_tcphdr ;
	struct udphdr pk_udphdr ;
} ;
