
/************************************************************************** 
 *     NNstat -- Internet Statistics Collection Package                   *
 *                                                                        *
 *        Written by: Bob Braden & Annette DeSchon                        *
 *        USC Information Sciences Institute                              *
 *        Marina del Rey, California                                      *
 *        1987-1988                                                       *
 *                                                                        *
 *     NNStat is Public Domain, and may be used for any purpose as long   *
 *     as this notice is not removed.                                     *
 **************************************************************************/
 
/*                  scan.h
 * 
 *   This file contains the syntax definitions required for lex and for
 *   the routines that call lex in scan.c and cmds.c.
 *
 */

/*
 * CHANGES:
 *   13Oct89 Katz: Access control tokens added
 *   17Oct89 AKS/RTB: Subnet token added
 */
 
/*  
 *      lex scan tokens
 */
#define EOFTOKEN        0
#define NUMBER          1
#define IPADDR          2
#define ETHERA          3
#define STRING          4
#define IDTOKEN         5
#define LABEL           6
#define CLASS           7
#define RECORD          10
#define IF              11
#define ELSE            12
#define INIS            13
#define ISNOT           14
#define ATTACH          20
#define DETACH          21
#define READ            22
#define CLEAR           23
#define READCL          24
#define SHOW            25
#define HELP            26
#define ENUM            27
#define RESTRICT        28
#define READONLY        29
#define READWRITE       30
#define SUBNET          31
                
union xlong {
        char xlbytes[MAX_DLENG];
        u_long xllong;
} ;

extern union values {
        int int_val;
        char *ptr_val;
        } yyval;

extern int LastToken, enumlist;
extern char yytext[];
extern int yyleng;

#define LEXCALL lexcall()
extern char *RsvdWds[];
extern int   RsvdToken[];
extern char *class_name[], *class_nick[];
extern FILE *yyin;
